unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AppEvent, RXSlider, ComCtrls;

type
  TForm1 = class(TForm)
    AliveTimer: TTimer;
    RecTimer: TTimer;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ListBox1: TListBox;
    TabSheet2: TTabSheet;
    cbIn1: TCheckBox;
    cbIn2: TCheckBox;
    cbIn3: TCheckBox;
    cbIn4: TCheckBox;
    cbIn5: TCheckBox;
    cbIn6: TCheckBox;
    cbIn7: TCheckBox;
    cbIn8: TCheckBox;
    edIn1: TEdit;
    edIn2: TEdit;
    edIn3: TEdit;
    edIn4: TEdit;
    edIn5: TEdit;
    edIn6: TEdit;
    edIn7: TEdit;
    edIn8: TEdit;
    edInA1: TEdit;
    edInA2: TEdit;
    edInA3: TEdit;
    edInA4: TEdit;
    edInA5: TEdit;
    edInA6: TEdit;
    edInA7: TEdit;
    edInA8: TEdit;
    RxSlider1: TRxSlider;
    Panel1: TPanel;
    Button2: TButton;
    RxSlider2: TRxSlider;
    RxSlider3: TRxSlider;
    RxSlider4: TRxSlider;
    RxSlider5: TRxSlider;
    RxSlider6: TRxSlider;
    RxSlider7: TRxSlider;
    RxSlider8: TRxSlider;
    cbO1: TCheckBox;
    cbO2: TCheckBox;
    cbO3: TCheckBox;
    cbO4: TCheckBox;
    cbO5: TCheckBox;
    cbO6: TCheckBox;
    cbO7: TCheckBox;
    cbO8: TCheckBox;
    cbStopInd: TCheckBox;
    edCommand: TEdit;
    btnSend: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure AliveTimerTimer(Sender: TObject);
    procedure RecTimerTimer(Sender: TObject);
    procedure RxSlider1Change(Sender: TObject);
    procedure cbO1Click(Sender: TObject);
    procedure cbR1Click(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    hCom: THandle;
    RecMess: string;
    OldRecMess: string;
    WatchTime: DWord;
    procedure CheckInput(port, index: integer);
    procedure SetInd(Port: integer);
    procedure ClrInd(Port: integer);
    procedure ValInd(Port: integer);
    procedure AngInd(Port: integer);
    procedure AddToLog(s: string);
    procedure CheckStatus;
    procedure AddToCommandEdit(s: string);
    procedure SendIt(s: string);
  public
    { Public declarations }
  end;

var
  Form1             : TForm1;

const
  LEGO_CLOCKWISE    = 1;
  LEGO_COUNTERCW    = 0;

implementation

{$R *.DFM}

const
  POWER_MASK        = $07;
  HEXCHARS          = '0123456789ABCDEF';

var
  ALIVE             : char = #$02;

  TURN_OFF          : char = #$90;
  TURN_ON           : char = #$91;

  SET_RIGHT         : char = #$93;
  SET_LEFT          : char = #$94;
  REVERSE           : char = #$95;

  SET_POWER         : byte = $B0;

  pressed           : array[0..7] of boolean = (FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE);
  rotation          : array[0..7] of integer = (0, 0, 0, 0, 0, 0, 0, 0);
  value             : array[0..7] of DWord;

procedure TForm1.AddToLog(s: string);
begin
  ListBox1.Items.Add(s);
  ListBox1.ItemIndex := Pred(ListBox1.Items.Count);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  dwError           : DWord;
  numBytes          : DWord;
  current           : integer;
  count             : integer;
  Found             : boolean;
  fResult           : longbool;
  dcb               : TDCB;
  buffer            : string;
  info              : string;
  tmo               : TCommTimeouts;
  Cmd               : string;
  tt                : DWord;
  Tries             : integer;
begin
  if Button2.Tag = 1 then begin         // Disconnect
    Button2.Caption := 'Connect';
    Button2.Tag := 0;
    TabSheet2.Enabled := False;

    AliveTimer.Enabled := False;

    Cmd := TURN_OFF + #$FF;
    WriteFile(hCom, Cmd[1], Length(Cmd), numbytes, nil);
    CloseHandle(hCom);
    RecTimer.Enabled := False;
  end
  else begin                            // Connect
 // Open serial
    hCom := CreateFile('COM2',
      GENERIC_READ or GENERIC_WRITE,
      0,                                // comm devices must be opened w/exclusive-access
      nil,                              // no security attrs
      OPEN_EXISTING,                    // comm devices must use OPEN_EXISTING
      0,
      0                                 // hTemplate must be NULL for comm devices
      );

    if (hCom = INVALID_HANDLE_VALUE) then begin
      dwError := GetLastError();
      AddToLog('Can''t create serial port handle');
      exit;
    end;

    fResult := GetCommState(hCom, dcb);
    if (not fResult) then begin
      AddToLog('Can''t get initial com port parameters');
      exit;
    end;

    dcb.BaudRate := 9600;
    dcb.ByteSize := 8;
    dcb.Parity := NOPARITY;
    dcb.StopBits := ONESTOPBIT;

 // Reset the com port to the new configuration
    fResult := SetCommState(hCom, dcb);
    if (not fResult) then begin
      AddToLog('Can''t set communication parameters');
      exit;
    end;
    AddToLog('COM2 successfully opened...');

 // Set communications timeout values
 // New setup reads all available chars, may return zero

    tmo.ReadIntervalTimeout := MAXDWORD; // 0
    tmo.ReadTotalTimeoutMultiplier := 0; //500;
    tmo.ReadTotalTimeoutConstant := 0;  //1000;
    tmo.WriteTotalTimeoutMultiplier := 0;
    tmo.WriteTotalTimeoutConstant := 0;
    fResult := fResult and SetCommTimeouts(hCom, tmo);

    SetLength(Info, 256);

    Tries := 5;
    repeat
      tt := GetTickCount;
 // Send greeting to lego box
      buffer := 'p'#0'###Do you byte, when I knock?$$$';
      WriteFile(hCom, Buffer[1], 34, numbytes, nil);
      if (numbytes <> 34) then begin
        AddToLog('Write failed');
      end;
 // Read in ###Just a bit off the block!$$$
 // Not much checking, just waiting for the $$$
      Current := 1;
      Count := 0;
      Found := FALSE;

 // Not very smart code yet, but seems to work...
      while (not Found) and ((GetTickCount - tt) < 200) do begin
        if ReadFile(hCom, Info[Current], 1, NumBytes, nil) and (NumBytes <> 0) then begin
          if (Info[Current] = '$') then
            Inc(Count);
          if (Count = 3) then
            Found := TRUE;
          Inc(Current, NumBytes);
        end
      end;
      Dec(Tries);
    until Found or (Tries <= 0);

    if not Found then begin
      AddToLog('Lego Control Box is not responding.');
      Showmessage('Lego Control Box is not responding.');
      CloseHandle(hCom);
      exit;
    end;

    ShowMessage('Lego Control Box successfully contacted!');
    AddToLog(Copy(info, Current - 32, 32));
    AliveTimer.Enabled := True;
    RecTimer.Enabled := True;
    WatchTime := GetTickCount;
    RecMess := '';
    OldRecMess := '';
    Button2.Caption := 'Disconnect';
    Button2.Tag := 1;
    TabSheet2.Enabled := True;
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TabSheet2.Enabled := False;
end;

procedure TForm1.AliveTimerTimer(Sender: TObject);
var
  NumBytes          : DWord;
begin
  WriteFile(hCom, ALIVE, 1, numbytes, nil)
end;

procedure TForm1.RecTimerTimer(Sender: TObject);
var
  Buffer            : string;
  s                 : string;
  NumBytes          : DWord;
  i, j              : integer;
  CheckSum          : integer;
begin
  SetLength(Buffer, 256);
  ReadFile(hCom, Buffer[1], 19, NumBytes, nil);
  if NumBytes > 0 then begin
    WatchTime := GetTickCount;
    i := 1;
    while NumBytes > 0 do begin
      RecMess := RecMess + Buffer[i];
      if Length(RecMess) = 19 then begin
        if OldRecMess <> RecMess then begin
          if (RecMess[1] in [#$00, #$10]) and (RecMess[2] = #$00) then begin
            s := '';
            CheckSum := 0;
            for j := 1 to 19 do begin
              s := s + Format('%x ', [Ord(RecMess[j])]);
              CheckSum := (CheckSum + Ord(RecMess[j])) and $FF;
            end;
            if CheckSum <> $FF then begin
              AddToLog('Checksum error!');
            end
            else begin
              AddToLog(s);
              CheckStatus;
              CheckInput(3, 2);
              CheckInput(7, 4);
              CheckInput(2, 6);
              CheckInput(6, 8);
              CheckInput(1, 10);
              CheckInput(5, 12);
              CheckInput(0, 14);
              CheckInput(4, 16);
              OldRecMess := RecMess;
            end;
            RecMess := '';
          end
          else begin                    // Out of synch??
            Delete(RecMess, 1, 1);
          end
        end
        else begin
          RecMess := '';
        end
      end;
      Inc(i);
      Dec(NumBytes);
    end
  end;

  if (GetTickCount - WatchTime) > 1000 then begin
    AddToLog('Lost contact with the Lego Control Box!');
    Button2Click(nil);
    RecTimer.Enabled := False;
    ShowMessage('Lost contact with the Lego Control Box!');
  end
end;

procedure TForm1.SetInd(Port: integer);
begin
  case Port of
    0: cbIn1.Checked := True;
    1: cbIn2.Checked := True;
    2: cbIn3.Checked := True;
    3: cbIn4.Checked := True;
    4: cbIn5.Checked := True;
    5: cbIn6.Checked := True;
    6: cbIn7.Checked := True;
    7: cbIn8.Checked := True;
  end
end;

procedure TForm1.ClrInd(Port: integer);
begin
  case Port of
    0: cbIn1.Checked := False;
    1: cbIn2.Checked := False;
    2: cbIn3.Checked := False;
    3: cbIn4.Checked := False;
    4: cbIn5.Checked := False;
    5: cbIn6.Checked := False;
    6: cbIn7.Checked := False;
    7: cbIn8.Checked := False;
  end
end;

procedure TForm1.ValInd(Port: integer);
begin
  case Port of
    0: edIn1.Text := IntToStr(Value[Port]);
    1: edIn2.Text := IntToStr(Value[Port]);
    2: edIn3.Text := IntToStr(Value[Port]);
    3: edIn4.Text := IntToStr(Value[Port]);
    4: edIn5.Text := IntToStr(Value[Port]);
    5: edIn6.Text := IntToStr(Value[Port]);
    6: edIn7.Text := IntToStr(Value[Port]);
    7: edIn8.Text := IntToStr(Value[Port]);
  end
end;

procedure TForm1.AngInd(Port: integer);
begin
  case Port of
    0: edInA1.Text := IntToStr(Rotation[Port]);
    1: edInA2.Text := IntToStr(Rotation[Port]);
    2: edInA3.Text := IntToStr(Rotation[Port]);
    3: edInA4.Text := IntToStr(Rotation[Port]);
    4: edInA5.Text := IntToStr(Rotation[Port]);
    5: edInA6.Text := IntToStr(Rotation[Port]);
    6: edInA7.Text := IntToStr(Rotation[Port]);
    7: edInA8.Text := IntToStr(Rotation[Port]);
  end
end;

procedure TForm1.CheckStatus;
begin
  if (Ord(RecMess[1]) and $10) <> 0 then begin
    // Stop button pressed on interface
    cbStopInd.Checked := True;
  end
  else begin
    cbStopInd.Checked := False;
  end
end;

procedure TForm1.CheckInput(Port, Index: integer);
var
  TouchEvent        : boolean;
  NewValue          : DWord;
  Direction         : integer;
  TurnAmount        : integer;
begin
 // Touch info
  TouchEvent := FALSE;
  if (Ord(RecMess[Index + 1]) = $2E) then begin
    TouchEvent := TRUE;
    if not Pressed[Port] then begin
      SetInd(Port);
      Pressed[Port] := True;
    end
  end
  else begin
    if Pressed[Port] then begin
      ClrInd(Port);
      Pressed[Port] := False;
      TouchEvent := TRUE;
    end
  end;

 // Light and Temperature info
  NewValue := Ord(RecMess[Index + 1]) * 4 + (Ord(RecMess[Index + 2]) and $C0) div 64;
  if (Value[Port] <> NewValue) then begin
    Value[Port] := NewValue;
//    if ((not TouchEvent) and (Value[Port] <> $3FF)) then begin
//      ValInd(Port);
//    end
//    else begin
//      Value[Port] := 0;
    ValInd(Port);
//    end
  end;

(*
  // Status
  Rotation[Port] := Ord(RecMess[Index + 2]) and $3F;
  AngInd(Port);
*)

 // Angle Info
  if (Ord(RecMess[Index + 2]) and $04) <> 0 then
    Direction := LEGO_CLOCKWISE
  else
    Direction := LEGO_COUNTERCW;

  TurnAmount := (Ord(RecMess[Index + 2]) and $03);
  if TurnAmount in [$01, $02, $03] then begin
    if (Direction = LEGO_CLOCKWISE) then
      Rotation[Port] := (Rotation[Port] + TurnAmount) mod 16
    else
      Rotation[Port] := (16 + Rotation[Port] - TurnAmount) mod 16;
    AngInd(Port);
  end

end;

procedure TForm1.RxSlider1Change(Sender: TObject);
var
  Cmd               : string;
begin
  with Sender as TRxSlider do begin
    Cmd := Char(SET_POWER or (Value and POWER_MASK));
    Cmd := Cmd + Char(1 shl Tag);
  end;
  SendIt(Cmd);
end;

procedure TForm1.cbO1Click(Sender: TObject);
var
  Cmd               : string;
begin
  with (Sender as TCheckBox) do begin
    if Checked then begin
      Cmd := TURN_ON;
    end
    else begin
      Cmd := TURN_OFF;
    end;
    Cmd := Cmd + Char(1 shl Tag);
    SendIt(Cmd);
  end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  Cmd               : string;
begin
  with (Sender as TButton) do begin
    if (Caption = 'R') then begin
      Caption := 'L';
      Cmd := SET_LEFT;
    end
    else begin
      Caption := 'R';
      Cmd := SET_RIGHT;
    end;
    Cmd := Cmd + Char(1 shl Tag);
  end;
  SendIt(Cmd);
end;

procedure TForm1.cbR1Click(Sender: TObject);
var
  Cmd               : string;
begin
  with (Sender as TButton) do begin
    Cmd := REVERSE + Char(1 shl Tag);
    SendIt(Cmd);
  end;
end;

procedure TForm1.AddToCommandEdit(s: string);
var
  i                 : integer;
  r                 : string;
begin
  r := '';
  for i := 1 to Length(s) do begin
    r := r + Format('%2.2x', [Ord(s[i])]) + ' ';
  end;
  edCommand.Text := r;
end;

procedure TForm1.btnSendClick(Sender: TObject);
var
  i                 : integer;
  s1                : string;
  s2                : string;
  State             : integer;
  v                 : integer;
  numbytes          : DWord;
begin
  s1 := UpperCase(edCommand.Text);
  s2 := '';
  State := 0;
  for i := 1 to Length(s1) do begin
    if Pos(s1[i], HEXCHARS) > 0 then begin
      case State of
        0: begin
            v := (Pos(s1[i], HEXCHARS) - 1);
            State := 1;
          end;
        1: begin
            v := (v shl 4) + (Pos(s1[i], HEXCHARS) - 1);
            s2 := s2 + Char(v);
            State := 0;
          end;
      end
    end
  end;
  if State = 0 then begin
    SendIt(s2);
  end
  else begin
    // Error, misformed hex
  end
end;

procedure TForm1.SendIt(s: string);
var
  BytesSent         : DWord;
begin
  WriteFile(hCom, s[1], Length(s), BytesSent, nil);
//  AddToCommandEdit(s);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if AliveTimer.Enabled then begin
    AliveTimer.Enabled := False;
    CloseHandle(hCom);
  end
end;

end.

